.\"
.\" Copyright (C) 1998 John D. Polstra.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY JOHN D. POLSTRA AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL JOHN D. POLSTRA OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\" $FreeBSD: src/usr.bin/lockf/lockf.1,v 1.1.1.1.2.3 1999/09/05 11:32:38 peter Exp $
.\"
.Dd July 7, 1998
.Os FreeBSD
.Dt LOCKF 1
.Sh NAME
.Nm lockf
.Nd execute a command while holding a file lock
.Sh SYNOPSIS
.Nm
.Op Fl ks
.Op Fl t Ar seconds
.Ar file
.Ar command
.Op Ar arguments
.Sh DESCRIPTION
The
.Nm
utility acquires an exclusive lock on a
.Ar file ,
creating it if necessary.
While holding the lock, it executes a
.Ar command
with optional
.Ar arguments .
After the
.Ar command
completes,
.Nm
releases the lock, and removes the
.Ar file
unless the
.Fl k
option is specified.  BSD-style locking is used, as described in
.Xr flock 2 ;
the mere existence of the 
.Ar file
is not considered to constitute a lock.
.Pp
The following options are supported:
.Bl -tag -width Fl
.It Fl k
Causes the lock file to be kept (not removed) after the command
completes.
.It Fl s
Causes
.Nm
to operate silently.
Failure to acquire the lock is indicated only in the exit status.
.It Fl t Ar seconds
Specifies a timeout for waiting for the lock.  By default,
.Nm
waits indefinitely to acquire the lock.
If a timeout is specified with this option,
.Nm
will wait at most the given number of
.Ar seconds
before giving up.  A timeout of 0 may be given, in which case
.Nm
will fail unless it can acquire the lock immediately.
.El
.Pp
In no event will
.Nm
break a lock that is held by another process.
.Sh DIAGNOSTICS
If
.Nm
successfully acquires the lock, it returns the exit status produced by
.Ar command .
Otherwise, it returns one of the exit codes defined in
.Xr sysexits 3 ,
as follows:
.Bl -tag -width F_CANTCREATX
.It Dv EX_TEMPFAIL
The specified lock file was already locked by another process.
.It Dv EX_CANTCREAT
.Nm
was unable to create the lock file, e.g., because of insufficient access
privileges.
.It Dv EX_USAGE
There was an error on the
.Nm
command line.
.It Dv EX_OSERR
A system call (e.g., fork) failed unexpectedly.
.El
.Sh SEE ALSO
.Xr flock 2 ,
.Xr sysexits 3
.Sh AUTHORS
.An John Polstra Aq jdp@polstra.com .
